// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#ifndef FENNEC_CORE_SCENE_H
#define FENNEC_CORE_SCENE_H

#include <fennec/containers/rdtree.h>
#include <fennec/langproc/strings/string.h>

namespace fennec
{

class scene : public rdtree<string> {
public:
	size_t operator[](const cstring& name) const {
		list<size_t> parse;
		parse.push_back(root);
		while (not parse.empty()) {
			if (*_data[parse.front()].value == name) {
				return parse.front();
			}
			parse.push_back(child(parse.front()));
			parse.push_back(next(parse.front()));
			parse.pop_front();
		}
		return npos;
	}

	size_t operator[](const string& name) const {
		list<size_t> parse;
		parse.push_back(root);
		while (not parse.empty()) {
			if (*_data[parse.front()].value == name) {
				return parse.front();
			}
			parse.push_back(child(parse.front()));
			parse.push_back(next(parse.front()));
			parse.pop_front();
		}
		return npos;
	}
};

}

#endif // FENNEC_CORE_SCENE_H
